package ca.uwaterloo.crysp.trainertouchalytics;

import java.util.ArrayList;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;

/**
 * This is demo code to accompany the Mobiletuts+ tutorial series:
 * - Android SDK: Create a Drawing App
 * 
 * Sue Smith
 * August 2013
 *
 */
public class DrawingView extends View {
	private Bitmap bitmap; // drawing area for display or saving
    private Canvas bitmapCanvas; // used to draw on bitmap
    private Paint paintLine; // used to draw lines onto bitmap   
    private Path mPath; 
    private ArrayList<Path> paths = new ArrayList<Path>();
    private ArrayList<Path> undonePaths = new ArrayList<Path>();
    private float mX, mY;
    private static final float TOUCH_TOLERANCE = 4;
    Context context_new;

    // DoodleView constructor initializes the DoodleView

    public DrawingView(Context context, AttributeSet attrs) 
    {
       super(context, attrs); // pass context to View's constructor
       this.context_new=context;
       setFocusable(true);
       setFocusableInTouchMode(true);      

       // set the initial display settings for the painted line
       paintLine = new Paint();
       paintLine.setAntiAlias(true); // smooth edges of drawn line
       paintLine.setDither(true);
       paintLine.setColor(Color.BLACK); // default color is black
       paintLine.setStyle(Paint.Style.STROKE); // solid line
       paintLine.setStrokeJoin(Paint.Join.ROUND);
       paintLine.setStrokeWidth(5); // set the default line width
       paintLine.setStrokeCap(Paint.Cap.ROUND); // rounded line ends

       bitmapCanvas = new Canvas();
       mPath = new Path();
       drawTarget();
     } // end DoodleView constructor

     // Method onSizeChanged creates BitMap and Canvas after app displays

     @Override
     public void onSizeChanged(int w, int h, int oldW, int oldH)
     {
        super.onSizeChanged(w, h, oldW, oldH);
        //DoodlzViewWidth = w;       
        //DoodlzViewHeight = h;           
     } 

     @Override
     protected void onDraw(Canvas canvas)  {       
    	 if (DebugActivity.state != DebugActivity.TRACE_STATE)
    		 return;
    	//Log.e("Swipes", paths.size());
       for (int i = 0; i <paths.size(); i++){
    	   if (i == 0) {
    		   paintLine.setColor(Color.GREEN);
    		   canvas.drawPath(paths.get(i), paintLine);
    	   }
    	   else {
    		   paintLine.setColor(Color.BLACK);
    		   canvas.drawPath(paths.get(i), paintLine);
    	   }
       }  
       canvas.drawPath(mPath, paintLine);
       //Log.i("OnDRAWING", "REACH ON DRAW");        
    } 

  // START TOUCH: handle touch event
     @Override
     public boolean onTouchEvent(MotionEvent event) 
     {            
          float x = event.getX();
          float y = event.getY();

          switch (event.getAction())
          {
              case MotionEvent.ACTION_DOWN:
                  touch_start(x, y);
                  invalidate();
                  break;
              case MotionEvent.ACTION_MOVE:
                 touch_move(x, y);
                  invalidate();
                  break;
              case MotionEvent.ACTION_UP:
                  touch_up();
                  invalidate();
                  break;
          }
          return true;
    }

     private void touch_start(float x, float y) {
       undonePaths.clear();
       mPath.reset();
       mPath.moveTo(x, y);
       mX = x;
       mY = y;
    }

    private void touch_move(float x, float y) {
        float dx = Math.abs(x - mX);
        float dy = Math.abs(y - mY);
        if (dx >= TOUCH_TOLERANCE || dy >= TOUCH_TOLERANCE) 
        {
            mPath.quadTo(mX, mY, (x + mX)/2, (y + mY)/2);
            mX = x;
            mY = y;
        }
    }  

    private void touch_up() {
        mPath.lineTo(mX, mY);      
        bitmapCanvas.drawPath(mPath, paintLine);// commit the path to our offscreen  
        if (paths.size() == 2) {
        	paths.remove(1);
        }
        paths.add(mPath);
        mPath = new Path(); 
    }
	
    public void drawTarget() {
		ArrayList<TouchPoint> tps = 
				MainActivity.victimRawTP.get(0);
		touch_start(tps.get(0).x, tps.get(0).y);
		for (int i = 0; i < tps.size(); i++) 
			touch_move(tps.get(i).x, tps.get(i).y);
		touch_up();

    }

    public void clearAll() {
		paths.clear();
		invalidate();
	}
	public void clear() {
		clearAll();
		drawTarget();
	}
	public void flipTrace(){
		//trace = !trace;
	}
}